.\"	$NetBSD: wcsdup.3,v 1.1 2006/08/26 22:48:50 christos Exp $
.\"
.\" Copyright (c) 1990, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)strdup.3	8.1 (Berkeley) 6/9/93
.\"
.Dd August 25, 2006
.Dt WCSDUP 3
.Os
.Sh NAME
.Nm wcsdup
.Nd save a copy of a string
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In wchar.h
.Ft wchar_t *
.Fn wcsdup "const wchar_t *str"
.Sh DESCRIPTION
The
.Fn wcsdup
function
allocates sufficient memory for a copy
of the wide character string
.Fa str ,
does the copy, and returns a pointer to it.
The pointer may subsequently be used as an
argument to the function
.Xr free 3 .
.Pp
If insufficient memory is available,
.Dv NULL
is returned.
.Sh EXAMPLES
The following will point
.Va p
to an allocated area of memory containing the nul-terminated string
.Qq foobar :
.Bd -literal -offset indent
wchar_t *p;

if (p = wcsdup(L"foobar"), p == NULL) {
	fprintf(stderr, "Out of memory.\en");
	exit(1);
}
.Ed
.Sh ERRORS
The
.Fn wcsdup
function may fail and set the external variable
.Va errno
for any of the errors specified for the library function
.Xr malloc 3 .
.Sh SEE ALSO
.Xr free 3 ,
.Xr malloc 3 ,
.Xr strdup 3
.Sh HISTORY
The
.Fn wcsdup
function first appeared in
.Nx 4.0 .
